#include <cv.h>
#include <highgui.h>
#include <stdio.h>
#include <math.h>

void quantization(IplImage *img, IplImage *img_quant) {
  int i, j;
  int height = img->height;
  int width  = img->width;
  int step   = img->widthStep;
  uchar *data= img->imageData;
  
  img_quant = cvCreateImage(cvGetSize(img), IPL_DEPTH_8U,1);
  uchar *data2 = img_quant->imageData;
  int step2  = img_quant->widthStep;

  for (i = 0; i < height; i ++) {
      for (j = 0; j < width; j++) {
	  // posicao (i,j) canal 0 = B
	  uchar C1 = (data[i*step+j*3+0] & 192)>>2;
	  uchar C2 = (data[i*step+j*3+1] & 192)>>4;
	  uchar C3 = (data[i*step+j*3+2] & 192)>>6;
	  data2[i*step+j] = C1 | C2 | C3;
      }
  }  
}

void normalize_histogram(long int *hist, double *hist_norm, int N, int factor) {
  int i;
  long int max = 0;
  long int sum = 0;
  for (i = 0; i < N; i++) {
      if (max < hist[i]) {
	 max = hist[i];
      }
      sum+= hist[i];
  }
  for (i = 0; i < N; i++) {
      hist_norm[i] = (hist[i]/(double)sum)*factor;
  }
}

void GCH(IplImage *img, double *descriptor) {
  int i, j;
  int height = img->height;
  int width  = img->width;
  int step   = img->widthStep;
  uchar *data= img->imageData;
  
  IplImage *img_quant;
  quantization(img, img_quant);
  
  long int *hist = calloc(64, sizeof(long int));
  // para cada pixel da imagem
  for (i = 0; i < (height*width); i++) {
      //incrementa posicao da cor data[i]
      hist[data[i]]++;
  }    
  normalize_histogram(hist, descriptor, 64, 1);
}
